//////////////////////////////////////////////////////////////////////////////////////////////////////
//	  AboutDlg.h
//////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#define BURA_RELEASE_NUM	_T("r.6")


#ifdef _WIN64
#define BURA_APP_NAME		_T("bura(64)")
#else
#define BURA_APP_NAME		_T("bura")
#endif
#define BURA_VER_BASE		_T("1.3.00beta5 Pad Version")
#ifdef _UNICODE
#define BURA_VER_ENC		_T("uc")
#else
#define BURA_VER_ENC		_T("mb")
#endif

#define BURA_APP_VER_NAME	BURA_APP_NAME _T(" ") BURA_VER_BASE _T(" (") BURA_RELEASE_NUM _T(" ") BURA_VER_ENC _T(")")


#include "OsVersion.h"


/////////////////////////////////////////////////////////////////////////////
//+++ unDonut about ̏x[Xɉ.

//+++ TuNXAWTL̂悤ɖ{̂ł̋Lq͂ł̂HA悭킩炸.

///+++ RsypNbNANbv{[hւ̃tL_Vo.
class CAboutDlg_Sub : public CEdit {
public:
	CAboutDlg_Sub() {}

	void Init(CWnd* pParent);
	void Term() { UnsubclassWindow(); }							//+++ ~

protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnLButtonUp(UINT nFlag, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CString		m_strInfo;		//+++
};


BEGIN_MESSAGE_MAP(CAboutDlg_Sub, CEdit)
	//{{AFX_MSG_MAP(CAboutDlg_Sub)
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CAboutDlg_Sub::Init(CWnd* pParent) {
	CEdit*	pEdit = (CEdit*)pParent->GetDlgItem(IDC_EDIT_ABOUT);
	SubclassWindow(pEdit->m_hWnd);			//+++ TuNX
	//eLXg{bNXɏݒ
	m_strInfo.Format(_T("%s\r\nOS : %s (%s) %s\r\nIE : %s%s\r\n")
					, BURA_APP_VER_NAME
					, COsVersion::OsName()
					, COsVersion::CSDVersion()
					, COsVersion::VersionStr()
					, COsVersion::IEVersionStr()
					, COsVersion::IEUpdateInfo()  );
	SetWindowText( m_strInfo );
}



void CAboutDlg_Sub::OnLButtonUp(UINT nFlags, CPoint point) {
	//eLXgSI
	this->SetSel( 0, m_strInfo.GetLength() );

	//j[\(Nbv{[hɃeLXgRs[邩ۂ)
	CMenu  menu;
	menu.CreatePopupMenu();
	menu.AppendMenu( 0, 1, _T("Nbv{[hɃRs[") );

	//ڂIꂽeLXgRs[
	CPoint pos;
	::GetCursorPos(&pos);
	int    nRet = menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_RETURNCMD | TPM_NONOTIFY, pos.x, pos.y, this/*m_hWnd*/);

	if (nRet == 1) {
		SetClipboardText(m_strInfo);
	}
	this->SetSel( -1, 0 );
}



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CAboutDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	virtual BOOL OnInitDialog();
	virtual void OnDestory();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	CToolTipCtrl 		wndToolTip;
	CAboutDlg_Sub		m_sub;			//+++
};


CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Tip ̐ݒ.
	wndToolTip.Create( this, TTS_BALLOON | TTS_ALWAYSTIP | TTS_NOPREFIX );
	wndToolTip.Activate(TRUE);
	wndToolTip.SetMaxTipWidth(320);
	wndToolTip.AddTool(this, _T("") );//GetDlgItem(IDC_STATIC1)

  #if 0	//+++ Rsyp̕\̍ւ́Aʓ|ȂŋC.
  #endif

	m_sub.Init(this);	//+++ Rsyp.

	return TRUE;		// Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
						// O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


void CAboutDlg::OnDestory()
{
	m_sub.Term();	//+++ RsyI.
	CDialog::OnDestroy();
}



BOOL CAboutDlg::PreTranslateMessage(MSG* pMsg)
{
	wndToolTip.RelayEvent(pMsg);//c[`bv
	return CDialog::PreTranslateMessage(pMsg);
}

void CAboutDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{ // 
	static unsigned int TsutsukiCount = 0;
	TsutsukiCount++;
	if (TsutsukiCount < 4) {
		return;
	}

	CRect rectBust( 30, 20, 43, 33 );
	CRect rectHip ( 28, 37, 43, 47 );
	CClientDC dc(this);
  #if 0
	// fobOplp
	COLORREF color = 0;
	CBrush 	 brush;
	brush.CreateSolidBrush(color);
	CBrush*  oldBrush = dc.SelectObject(&brush);
	dc.FrameRect(rectBust, &brush);
  #endif
	// 
	CString strCmd;
	if (rectBust.PtInRect(point)) {
		srand((unsigned)time(NULL));
		int rnd = rand()%20;
		switch(rnd){
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
			strCmd= _T("M͈̃^uuEUɉ߂Ă̂łB");
			break;
		case 5:
			strCmd= _T("ɐG邱Ƃ͎ӖbI\nuebfBEpہvI");
			break;
		case 6:
		case 7:
			strCmd= _T("G@\łقǐ̒ẤB");
			break;
		case 8:
		case 9:
		case 10:
			strCmd= _T("yłccH");
			break;
		case 11:
			strCmd= _T("ȂɃA^V点̂ȂeEbB\nꂪ}ɂȂI");
			break;
		case 12:
		case 13:
			strCmd= _T("BI");
			break;
		}
//		DirectSSTPSendMessage(m_hWnd, _T("bura")  , strCmd +  _T("\\e") , "");
	}
	// K
	else if (rectHip.PtInRect(point)) {
		srand((unsigned)time(NULL));
		int rnd = rand()%20;
		switch(rnd){
		case 0:
		case 1:
		case 2:
		case 3:
			strCmd= _T("M͈̃^uuEUɉ߂Ă̂łB");
			break;
		case 4:
			strCmd= _T("Η̈B");
			break;
		case 5:
		case 6:
		case 7:
			strCmd= _T("RR͗LłB\n\nccRǁB");
			break;
		case 8:
			strCmd= _T("ɐG邱Ƃ͎ӖbI\nuebfBEpہvI");
			break;
		case 9:
		case 10:
			strCmd= _T("ĉ_Ƃ́B\nӖA{łˁB");
			break;
		case 11:
		case 12:
			strCmd= _T("EUłǁB");
			break;
		case 13:
		case 14:
			strCmd= _T("BI");
			break;
		}
	}


	if (strCmd!= _T("") ) {
		wndToolTip.SetDelayTime(TTDT_AUTOPOP  , 5000);
		wndToolTip.UpdateTipText(strCmd , this , 0);
		//	DirectSSTPSendMessage(m_hWnd, _T("bura")  , strCmd +  _T("\\e") , "");
	}
	CDialog::OnLButtonDblClk(nFlags, point);
}


