/////////////////////////////////////////////////////////////////////////////
// DropTarget.cpp: CDropTarget NX̃Cve[V
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "DropTarget.h"
#include "MainFrm.h"
#include "patriotGlobal.h"
#include "patriotView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// \z/
/////////////////////////////////////////////////////////////////////////////

CDropTarget::CDropTarget()
	: m_nParent(0)
{

}

CDropTarget::~CDropTarget()
{

}
DROPEFFECT CDropTarget::OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
  #if 0
	/*
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();

	switch(m_nParent){
	case OLE_TARGET_FAVORITES://Cɓ
		HTREEITEM item;
		CTreeCtrl* pTree=&pMainFrame->m_wndSideBar.TreeFavorites;
		item = pTree->HitTest(point);
		pTree->SelectDropTarget(item);
	}
	*/
  #endif
	return DROPEFFECT_COPY;
}

DROPEFFECT CDropTarget::OnDropEx( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point )
{ // hbv
  #if 1
	enum { max_path = 1024 };		//+++ Url  MAX_PATH(260)Ă...0x8000? ... ܂łĂȂ̂.
  #else
	enum { max_path = MAX_PATH };
  #endif
	CMainFrame* pMainFrame = (CMainFrame*)AfxGetMainWnd();
	// f[^擾
	// TEXT
	TCHAR lpszText[max_path];
	if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
		HGLOBAL 	 hData = pDataObject->GetGlobalData(BURA_CF_TEXT);
		const TCHAR* ptr   = static_cast<const TCHAR*>( ::GlobalLock(hData) );
		lstrcpyn(lpszText, ptr, max_path);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}
	// FILE
	enum { FILE_NUM = 128 };	//+++
	TCHAR	lpszFiles[FILE_NUM][_MAX_PATH];
	UINT 	nFiles = 0;
	if (pDataObject->IsDataAvailable(CF_HDROP)) {
		HGLOBAL hData 	  = pDataObject->GetGlobalData(CF_HDROP);
		HDROP	hDropInfo = static_cast<HDROP>( ::GlobalLock(hData) );

		nFiles = ::DragQueryFile( hDropInfo, (UINT)-1, NULL, 0 );
		if (nFiles > FILE_NUM)	//+++
			nFiles = FILE_NUM;
		for (UINT nFile = 0; nFile < nFiles; nFile++) {
			::DragQueryFile( hDropInfo, nFile, lpszFiles[nFile], _MAX_PATH );
		}
		::DragFinish(hDropInfo);
		::GlobalUnlock(hData);
		::GlobalFree(hData);
	}

	//HTREEITEM item;
	CString 	strPath;
	//CTreeCtrl* pTree;

	switch (m_nParent) {
	case OLE_TARGET_TABBAR://^uo[
		{
			// hbv擾
			// ver1.0.08 ^uo[̂Ƃ D&D oȂoOC
			pMainFrame->ClientToScreen(&point);
			pMainFrame->m_wndTabBar.ScreenToClient(&point);

			TCHITTESTINFO info = {0};
			info.pt    = point;
			info.flags = TCHT_ONITEM;

			if (pDataObject->IsDataAvailable( (CLIPFORMAT)RegisterClipboardFormat(_T("Bura.TabIndex")) )) {
				// ^ũCfbNX
				int Index = pMainFrame->m_wndTabBar.HitTest( &info );
				if (Index >= 0) {
					HGLOBAL hData	 = pDataObject->GetGlobalData( (CLIPFORMAT)RegisterClipboardFormat(_T("Bura.TabIndex")) );
					int 	TabIndex = *(const int *)GlobalLock(hData);
					GlobalUnlock(hData);
					::GlobalFree(hData);
					pMainFrame->SendMessage( WM_INSERTTAB, TabIndex, Index );
				}
				return DROPEFFECT_MOVE;
			} else if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
				// TEXT
				int Index = pMainFrame->m_wndTabBar.HitTest(&info);
				if (Index >= 0) {
					pMainFrame->m_Tabs.pView[Index]->Navigate(lpszText);
				} else if (::_tcsstr((lpszText),_T("://"))) {
					CHtmlView2* pView = ((CPatriotApp*)AfxGetApp())->NewTab( 4 );
					pView->Navigate( lpszText );
				} else {
					::OpenAnyFile(lpszText);
				}
				return DROPEFFECT_COPY;
			}
		}
		break;
	case OLE_TARGET_ADDRESSBAR://AhXo[
		if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
			pMainFrame->m_wndAddressBar.SetWindowText(lpszText);
			pMainFrame->m_wndAddressBar.SetFocus();
			return DROPEFFECT_COPY;
		}
		break;
	case OLE_TARGET_SEARCHBAR://o[
		if (pDataObject->IsDataAvailable(BURA_CF_TEXT)) {
			CComboBox* pCombo = (CComboBox*)pMainFrame->m_wndSearchBar.GetDlgItem(IDC_COMBO1);
			pCombo->SetWindowText(lpszText);
			pCombo->SetFocus();
			return DROPEFFECT_COPY;
		}
		break;
  #if 0	//+++ ǂłȂ̂ȂAɁAKɃy[WJ邩邩Ƃ.
	case OLE_TARGET_CHILDFRAME:	// y[W
		if (pDataObject->IsDataAvailable(cf_text)) {
			if (::_tcsstr((lpszText),_T("://"))) {
				CHtmlView2* pView = ((CPatriotApp*)AfxGetApp())->NewTab( 4 );
				pView->Navigate( lpszText );
			} else {
				CComboBox* pCombo = (CComboBox*)pMainFrame->m_wndSearchBar.GetDlgItem(IDC_COMBO1);
				pCombo->SetWindowText(lpszText);
				pCombo->SetFocus();
			}
			return DROPEFFECT_COPY;
		}
		break;
  #endif
  #if 0
	/*
	case OLE_TARGET_FAVORITES://Cɓ
		pTree=&pMainFrame->m_wndSideBar.TreeFavorites;
		item = pTree->HitTest(point);
		if (!pTree->ItemHasChildren(item))
			item = pTree->GetParentItem(item);
		strPath = pMainFrame->m_wndSideBar.TreeFavorites.GetItemFileName(item);
		if (strPath.Right(1)== _T("\\") )
			strPath = strPath.Left(strPath.GetLength()-1);
		// t@C
		if (pDataObject->IsDataAvailable(CF_HDROP)) {
			SHFILEOPSTRUCT shFile;
			shFile.hwnd = this->m_hWnd;
			shFile.wFunc = FO_MOVE;
			shFile.fFlags = FOF_ALLOWUNDO | FOF_MULTIDESTFILES;// | FOF_NOCONFIRMMKDIR | FOF_RENAMEONCOLLISION
			for (UINT i = 0;i<nFiles;i++) { // Rs[
			//	if (stricmp(lpszFiles[i]+strlen(lpszFiles[i])-4, _T(".url") ) == 0) {
					shFile.pTo	=strPath+strrchr(lpszFiles[i], '\\');
					shFile.pFrom = lpszFiles[i];

					SHFileOperation(&shFile);
					if (!shFile.fAnyOperationsAborted) { // c[ɒǉ
						CString strTitle = strrchr(lpszFiles[i], '\\')+1;
						strTitle = strTitle.Left(strTitle.GetLength()-4);
						// ACëړ
						pTree->LockWindowUpdate();
						pMainFrame->m_wndSideBar.TreeFavorites.AddFolder(strPath , item);
						pTree->UnlockWindowUpdate();
					}
			//	}
			}
			return DROPEFFECT_COPY;
		}
		// N
		else if (pDataObject->IsDataAvailable(RegisterClipboardFormat(CFSTR_INETURL/*+++CFSTR_SHELLURL*/))) {
			HGLOBAL hData = pDataObject->GetGlobalData(RegisterClipboardFormat(CFSTR_FILEDESCRIPTOR));
			FILEGROUPDESCRIPTOR* fd = (FILEGROUPDESCRIPTOR*)GlobalLock(hData);
			CString strTitle = fd->fgd[0].cFileName;
			WriteShortcut(strPath+_T("\\")+strTitle , chrText);
			strTitle = strTitle.Left(strTitle.GetLength()-4);
			// ACëړ
			pTree->LockWindowUpdate();
			pMainFrame->m_wndSideBar.TreeFavorites.AddFolder(strPath , item);
			pTree->UnlockWindowUpdate();

			GlobalUnlock(hData);
			::GlobalFree(hData);
			return DROPEFFECT_COPY;
		}
		break;
	case OLE_TARGET_URLLIST://URLXg
		pTree=&pMainFrame->m_wndSideBar.TreeUrllist;
		item = pTree->HitTest(point);
		if (pTree->ItemHasChildren(item) || item == NULL)
			return DROPEFFECT_NONE;
		// t@Co
		while (pTree->GetParentItem(item)) {
			strPath = pTree->GetItemText(item) +  _T("\\")	+ strPath;
			item = pTree->GetParentItem(item);
		}
		strPath = g_Options.strAppPath +  _T("\\urllist\\") + pTree->GetItemText(item) + _T("\\")  + strPath;
		if (strPath.Right(1)== _T("\\") )
			strPath = strPath.Left(strPath.GetLength()-1)+ _T(".bura");
		else
			strPath+= _T(".bura");
		// N
		if (pDataObject->IsDataAvailable(RegisterClipboardFormat(CFSTR_INETURL/*+++CFSTR_SHELLURL*/))) {
			CString str , str2;
			CStdioFile fin(strPath , CFile::modeRead);
			while(fin.ReadString(str2))
				str += str2 +  _T("\n");
			fin.Close();

			CStdioFile fin2(strPath , CFile::modeCreate | CFile::modeWrite);
			fin2.WriteString(str);
			strcat(chrText, _T("\n") );
			fin2.WriteString(chrText);
			fin2.WriteString( _T("22222222222\n") );
			fin2.WriteString( _T("\n") );
			fin2.Close();
			return DROPEFFECT_COPY;
		}
		// ^u
		else if (pDataObject->IsDataAvailable(RegisterClipboardFormat( _T("Bura.TabIndex") ))) {
			HGLOBAL hData = pDataObject->GetGlobalData(RegisterClipboardFormat( _T("Bura.TabIndex") ));
			int TabIndex = *(const int *)GlobalLock(hData);
			GlobalUnlock(hData);
			::GlobalFree(hData);
			CString str , str2;
			CStdioFile fin(strPath , CFile::modeRead);
			while(fin.ReadString(str2))
				str += str2 +  _T("\n");
			fin.Close();

			CStdioFile fin2(strPath , CFile::modeCreate | CFile::modeWrite);
			fin2.WriteString(str);
			fin2.WriteString(pMainFrame->m_Tabs.pView[TabIndex]->GetLocationURL()+ _T("\n") );
			fin2.WriteString(((CPatriotView*)pMainFrame->m_Tabs.pView[TabIndex])->SaveStrSetting() + _T("\n") );
			fin2.WriteString( _T("\n") );
			fin2.Close();
			return DROPEFFECT_COPY;
		}
		break;
	*/
  #endif
	}
	return DROPEFFECT_NONE;
}
