/////////////////////////////////////////////////////////////////////////////
// PatriotAddress.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "MainFrm.h"
#include "patriotGlobal.h"
#include "DropTarget.h"
#include "PatriotAddress.h"
#include "punycode/punycode.h"
#include <wininet.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPatriotAddress

inline bool AttachAutoComplete(HWND hWnd, BOOL bEnable = true)
{
	DWORD dwFlags = bEnable ? (SHACF_FILESYSTEM | SHACF_URLALL | SHACF_USETAB) : (SHACF_AUTOAPPEND_FORCE_OFF | SHACF_AUTOSUGGEST_FORCE_OFF);

	bool bResult = false;
	HINSTANCE hLib = ::LoadLibrary(_T("shlwapi.dll"));
	if (hLib) {
		typedef HRESULT (CALLBACK *LPFNSHAUTOCOMPLETE)(HWND, DWORD);
		LPFNSHAUTOCOMPLETE lpfnSHAutoComplete = (LPFNSHAUTOCOMPLETE)::GetProcAddress(hLib, "SHAutoComplete");
		if (lpfnSHAutoComplete) {
			HRESULT hr = (*lpfnSHAutoComplete)(hWnd, dwFlags);//SHACF_FILESYSTEM | SHACF_URLALL | SHACF_USETAB
			if (SUCCEEDED(hr)) {
				bResult = true;
			}
		}
		::FreeLibrary(hLib);
	}
	return bResult;
}

CPatriotAddress::CPatriotAddress()
	: m_oDropTarget()
	, arrMenuStr()
{
}

CPatriotAddress::~CPatriotAddress()
{
}


BEGIN_MESSAGE_MAP(CPatriotAddress, CComboBoxEx)
	//{{AFX_MSG_MAP(CPatriotAddress)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_CONTROL_REFLECT(CBN_SELCHANGE, OnSelchange)
	ON_WM_KEYDOWN()
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(CBEN_GETDISPINFO, OnGetdispinfo)
	ON_NOTIFY_REFLECT(CBEN_DRAGBEGIN, OnDragbegin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPatriotAddress bZ[W nh

/// y[WɈړ
void CPatriotAddress::GoUrl()
{
	BOOL bShift		= (GetKeyState(VK_SHIFT)   & 0x8000);
	BOOL bCtrl		= (GetKeyState(VK_CONTROL) & 0x8000);

	CString	strURL;
	GetWindowText(strURL);

	BOOL bNewWindow = g_Options.bNWAddress;

	// ɒǉ
	TCHAR	strBuf[INTERNET_MAX_URL_LENGTH];
	COMBOBOXEXITEM item = {0};
	item.mask		= CBEIF_TEXT;
	item.pszText	= strBuf;
	item.cchTextMax = INTERNET_MAX_URL_LENGTH;
	item.iItem		= 0;
	lstrcpyn(strBuf, strURL, INTERNET_MAX_URL_LENGTH);
	InsertItem(&item);
	SetCurSel(0);

	for (int i = GetCount() - 1; i >= 1; i--) { // d̃`FbN
		item.iItem	= i;
		GetItem(&item);

		if (strURL == item.pszText) { // 폜
			DeleteItem(i);
		}
	}

	if (GetCount() > g_Options.AddressHistoryCount) {
		DeleteItem( GetCount() - 1 );
	}

	// Shift or Ctrl
	CString* pStrAddressCtrl = NULL;
	if (bShift && bCtrl) {
		pStrAddressCtrl = &g_Options.strAddressCtrl3;
	} else if (bCtrl) {
		pStrAddressCtrl = &g_Options.strAddressCtrl1;
	} else if (bShift) {
		pStrAddressCtrl = &g_Options.strAddressCtrl2;
	}
	if (pStrAddressCtrl) {
		if (pStrAddressCtrl->IsEmpty()) {
			bNewWindow = !bNewWindow;
		} else{
			OpenSendstring(*pStrAddressCtrl, strURL, bNewWindow, -1, _T("sendurl.ini") );
			return;
		}
	}

	if (strURL.GetLength() > 4 &&  strURL.Left(4)== _T("run:") ) { // t@C̎s
		RunCommand(strURL);
		return;
	}
	if (strURL.GetLength() > 0 && strURL.GetAt(0) == _T('0')) { // o[ɃRs[
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		/*
		CComboBox* pCombo2 = (CComboBox*)pFrame->m_wndSearchBar.GetDlgItem(IDC_COMBO2);
		pCombo2->SetWindowText(strURL);
		*/
		pFrame->m_wndSearchBar.SetDlgItemText( IDC_COMBO1, strURL );
		pFrame->m_wndSearchBar.GoUrl();
		return;
	}

	CHtmlView2* pView;
	CPatriotApp* pApp = (CPatriotApp*)AfxGetApp();

	if (bNewWindow) { // VKEBhE
		pView = pApp->NewTab( 1, g_Options.bATAddress );
	} else {
		CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
		if (pFrame->MDIGetActive()) {
			pView = static_cast<CHtmlView2*>(pFrame->MDIGetActive()->GetActiveView());
		} else {
			pView = pApp->NewTab( 1, g_Options.bATAddress );
		}
	}
	if (pView) {
		pView->Navigate( EncodePunycodeURL(strURL) );
		if (g_Options.bATAddress) {
			AfxGetMainWnd()->PostMessage( WM_COMMAND, ID_VIEW_FOCUS_VIEW );
		}
	}
}

/// URL ݒ
void CPatriotAddress::SetUrlText(CString& strUrl)
{
	CMDIFrameWnd*	pMainWnd  = static_cast<CMDIFrameWnd*>(AfxGetMainWnd());
	static CString  strOldUrl = _T("");
	if ( (!strUrl.IsEmpty() || pMainWnd->MDIGetActive() == NULL) && strUrl != strOldUrl) {
		// Ver1.0.06 
		if ( _tcsstr( strUrl, _T("xn--") ) ) {
			strUrl = DecodePunycodeURL(strUrl);
		}

		//SetWindowText( strUrl/*DecodePunycodeURL( strUrl )*/ );
		TCHAR szText[INTERNET_MAX_URL_LENGTH];
		lstrcpyn(szText, strUrl, INTERNET_MAX_URL_LENGTH);

		COMBOBOXEXITEM cbi = {0};
		cbi.iItem		   = -1;
		cbi.mask		   = CBEIF_TEXT | CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
		cbi.pszText 	   = szText;
		cbi.cchTextMax	   = INTERNET_MAX_URL_LENGTH;
		cbi.iImage		   = I_IMAGECALLBACK;
		cbi.iSelectedImage = I_IMAGECALLBACK;
		SetItem(&cbi);

		strOldUrl = strUrl;
	}
}

/// f[^ǂݍ
void CPatriotAddress::LoadItem()
{
	// ACR
	//+++ static CImageList* pPrevImageList = 0; //+++ fobOmF.
	CImageList* pOldImageList = GetImageList();
	if (pOldImageList) {
		pOldImageList->DeleteImageList();
		delete pOldImageList;		//+++ ԂRĂāA[NĂ邱Ƃ.
	}
	if (g_Options.AddressShowIcon) {
		HICON		hIcon		= AfxGetApp()->LoadIcon(IDR_PATRIOTYPE);
		CImageList* pImageList	= new CImageList;
		pImageList->Create(16, 16, ILC_MASK | ILC_COLOR32, 0, 1);
		pImageList->Add(hIcon);
		SetImageList(pImageList);
		//+++ pPrevImageList = pImageList; debugmFp.
		DestroyIcon(hIcon);
	} else {
		SetImageList(NULL);
	}

	// I[gRv[g
	AttachAutoComplete(GetEditCtrl()->m_hWnd, g_Options.AddressAutoComplete);

	// ReLXgj[
	CString str;
	arrMenuStr.RemoveAll();
	TRY{
		CReadTextFile	fin;		//+++ CStdioFile fin;
		fin.Open( g_Options.strOptionPath + _T("\\addrmenu.dat"), CFile::modeRead );
		while (fin.ReadString(str)) {
			if (str.Left(2) == _T("--")) { // Zp[^
				if (arrMenuStr.GetSize() > 0 && arrMenuStr.GetAt( arrMenuStr.GetSize() - 1 ).Left(2)== _T("--") ) {
					// AŃZp[^񂾂ƂɃftHg̃j[}
					arrMenuStr.RemoveAt( arrMenuStr.GetSize() - 1 );
					arrMenuStr.Add( _T("ɖ߂(&U)") );
					arrMenuStr.Add( _T("-----------") );
					arrMenuStr.Add( _T("؂(&T)") );
					arrMenuStr.Add( _T("Rs[(&C)") );
					arrMenuStr.Add( _T("\t(&P)") );
					arrMenuStr.Add( _T("폜(&D)") );
					arrMenuStr.Add( _T("-----------") );
					arrMenuStr.Add( _T("ׂđI(&A)") );
				}
				arrMenuStr.Add( _T("-----------") );
			}
			else if (str.GetAt(0) != _T('#')) {
				arrMenuStr.Add(str);
			}
		}
		fin.Close();
		// URL𑗂ǉ
		if (g_Options.AddressAddSendurl) {
			fin.Open(g_Options.strOptionPath + _T("\\sendurl.dat"), CFile::modeRead);
			while (fin.ReadString(str)) {
				if (str.Left(2) == _T("--") ) {// Zp[^
					arrMenuStr.Add( _T("-----------") );
				}
				else if (str.GetAt(0) != _T('#')) {
					arrMenuStr.Add(str);
				}
			}
			fin.Close();
		}
	}
	CATCH( CFileException, e ){
		if ( e->m_cause != CFileException::fileNotFound) {
			TRACE( _T("File could not be opened %d \n")  , e->m_cause);
		}
	}END_CATCH
}

/// ͗ǂݍ
void CPatriotAddress::LoadHistory()
{
	ResetContent();
	if (g_Options.AddressHistoryCount > 0) {
		TRY{
			//+++ CStdioFile fin(g_Options.strOptionPath + _T("\\address.dat"), CFile::modeRead);
			CReadTextFile	fin(g_Options.strOptionPath + _T("\\address.dat"), CFile::modeRead);
			COMBOBOXEXITEM	item = {0};
			item.iItem	= 0;
			item.mask	= CBEIF_TEXT | CBEIF_IMAGE | CBEIF_SELECTEDIMAGE;
		  #if 1 //def UNICODE	//+++ CReadTextFile̎蔲CStringɂΉĂȂ̂ŏ.
			CString		buf;
			while (fin.ReadString(buf, INTERNET_MAX_URL_LENGTH)) {
				item.pszText		= (LPTSTR) LPCTSTR(buf);
				item.iImage 		= I_IMAGECALLBACK;
				item.iSelectedImage = I_IMAGECALLBACK;
				InsertItem(&item);

				item.iItem++;
			}
		  #else
			TCHAR pszText[INTERNET_MAX_URL_LENGTH];
			while (fin.ReadString(pszText, INTERNET_MAX_URL_LENGTH)) {
				int len = lstrlen(pszText);
				if (pszText[len - 1] == _T('\n')) {
					pszText[len - 1] = _T('\0');
				}

				item.pszText		= pszText;
				item.iImage 		= I_IMAGECALLBACK;
				item.iSelectedImage = I_IMAGECALLBACK;
				InsertItem(&item);

				item.iItem++;
			}
		  #endif
			fin.Close();
		}
		CATCH( CFileException, e ){
			if ( e->m_cause != CFileException::fileNotFound) {
				TRACE( _T("File could not be opened %d \n")  , e->m_cause);
			}
		}END_CATCH
	}
}

/// Ǝj[@point̓NCAgW
void CPatriotAddress::CreatePopupMenu(CPoint point)
{
	CWnd* pWndFocus = GetFocus();
	if (pWndFocus != GetComboBoxCtrl()->GetWindow(GW_CHILD)) {
		SetFocus();
	}

	CMenu menu;
	menu.CreatePopupMenu();

	for (int i = 0; i < arrMenuStr.GetSize(); i++) {
		if (arrMenuStr.GetAt(i).Left(2) == _T("--") ) {
			// Zp[^[
			menu.AppendMenu(MF_SEPARATOR , NULL, _T("") );
		} else if (arrMenuStr.GetAt(i).GetAt(0) != '#') {
			// 
			CString str = arrMenuStr.GetAt(i);
			// V[gJbg\
			if (str == g_Options.strAddressCtrl1) {
				str+= _T("\tCtrl+Enter");
			}
			if (str == g_Options.strAddressCtrl2) {
				str+= _T("\tShift+Enter");
			}
			if (str == g_Options.strAddressCtrl3) {
				str+= _T("\tCtrl+Shift+Enter");
			}

			menu.AppendMenu( MF_STRING, ID_ADDRESS_GO + i, str );
		}
	}
	ClientToScreen( &point );

	//menu.TrackPopupMenu( NULL, point.x, point.y, this );
	UINT nID = TrackPopupMenu( menu.m_hMenu, TPM_LEFTALIGN | TPM_RETURNCMD, point.x, point.y, 0, m_hWnd, NULL );
	if (nID == 0) {
		return;
	}
	// ƎR}h̎s
	CString str = arrMenuStr.GetAt(nID - ID_ADDRESS_GO);
	if (str== _T("app:Go") ) {						// ړ
		GoUrl();
	} else if (str.Find( _T("ɖ߂") ) == 0) {	// ɖ߂
		GetEditCtrl()->Undo();
	} else if (str.Find( _T("؂") ) == 0) {	// ؂
		GetEditCtrl()->Cut();
	} else if (str.Find( _T("Rs[") ) == 0) { 	// Rs[
		GetEditCtrl()->Copy();
	} else if (str.Find( _T("\t") ) == 0) {	// \t
		GetEditCtrl()->Paste();
	} else if (str.Find( _T("폜") ) == 0) {		// 폜
		GetEditCtrl()->Clear();
	} else if (str.Find( _T("ׂđI") ) == 0) { // ׂđI
		GetEditCtrl()->SetSel(0, -1);
	} else if (str.Find( _T("ړ") ) == 0) {		// ړ
		GoUrl();
	} else {										// ̑
		CString str2;
		GetWindowText(str2);
		OpenSendstring( str, str2, g_Options.bNWAddress, -1, _T("sendurl.ini") );
	}
}

/// \z
int CPatriotAddress::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CComboBoxEx::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	// ǂݍ
	if (g_Options.AddressAutoComplete) {
		AttachAutoComplete(GetEditCtrl()->m_hWnd);
	}
	LoadItem();
	LoadHistory();

	// OLE
	m_oDropTarget.m_nParent = OLE_TARGET_ADDRESSBAR;
	m_oDropTarget.Register(this);
	return 0;
}

/// j
void CPatriotAddress::OnDestroy()
{
	// ۑ
	if (g_Options.AddressHistoryCount > 0) {
		//+++ CStdioFile fin(g_Options.strOptionPath + _T("\\address.dat"), CFile::modeCreate | CFile::modeWrite);
		CWriteTextFile fin(g_Options.strOptionPath + _T("\\address.dat"), CFile::modeCreate | CFile::modeWrite);
		TCHAR str[INTERNET_MAX_URL_LENGTH+2];
		int nCount = GetComboBoxCtrl()->GetCount();
		for (int i = 0; i < nCount; i++) {
			COMBOBOXEXITEM	cbi = {0};
			cbi.iItem	   = i;
			cbi.mask	   = CBEIF_TEXT;
			cbi.pszText    = str;
			cbi.cchTextMax = INTERNET_MAX_URL_LENGTH;

			GetItem(&cbi);
			lstrcat(str, _T("\n"));
			fin.WriteString(str);
		}
		fin.Close();
	}
	CImageList* pImageList = GetImageList();
	if (pImageList) {
		pImageList->DeleteImageList();	//+++ ꂵƂȂGetImageList()̃|C^NULLɂȂȂ(A[N?)
		delete pImageList;
	}
	CComboBox::OnDestroy();
}

BOOL CPatriotAddress::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN) {// L[
		GoUrl();
	}
	if (pMsg->message == WM_MBUTTONDOWN) {
		GoUrl();
	}
	if (pMsg->message == WM_KEYDOWN && pMsg->wParam == 'A' && (GetKeyState(VK_CONTROL) & 0x8000)) { // ׂđI
		GetEditCtrl()->SetSel(0, -1);
		return TRUE;
	}
	// ~
	if(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE
		&& !(GetKeyState(VK_SHIFT) & 0x8000) && !(GetKeyState(VK_CONTROL) & 0x8000) && !(GetKeyState(VK_MENU) & 0x8000) ){
		CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
		if (pFrame->MDIGetActive()) {
			CHtmlView2* pView = (CHtmlView2*)pFrame->MDIGetActive()->GetActiveView();
			SetWindowText( pView->GetLocationURL() );
			PostMessage(WM_COMMAND , ID_VIEW_STOP);
			return TRUE;
		}
	}
	if (pMsg->message == WM_RBUTTONDOWN) {
		POINT point = {LOWORD(pMsg->lParam), HIWORD(pMsg->lParam)};
		CreatePopupMenu(point);
		return TRUE;
	}
	if (pMsg->message == WM_CONTEXTMENU) {
		CRect rect;
		GetWindowRect(rect);
		rect.right	-= rect.Width()/2;
		rect.bottom -= rect.Height()/2;

		OnContextMenu( this, CPoint(rect.right, rect.bottom) );
		return TRUE;
	}
	return CComboBox::PreTranslateMessage(pMsg);
}


void CPatriotAddress::OnSelchange()
{ // Xg̕ύX
	if (g_Options.AddressGoHistory) {// ړ
		GoUrl();
	}
}

void CPatriotAddress::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{ // L[
	if (nChar == VK_F4 && nRepCnt <= 1) {
		ShowDropDown(TRUE);
	}
	CComboBoxEx::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CPatriotAddress::OnContextMenu(CWnd* pWnd, CPoint point)
{ // Ǝj[
	ScreenToClient(&point);
	CreatePopupMenu(point);
}

void CPatriotAddress::OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult)
{
	PNMCOMBOBOXEX pDispInfo = (PNMCOMBOBOXEX)pNMHDR;
	COMBOBOXEXITEM& item = pDispInfo->ceItem;

	if (!g_Options.AddressShowIcon) {
		return;
	}

	CString str;
	if (GetComboBoxCtrl()->GetDroppedState()) {
		GetLBText(int(item.iItem), str);
	} else {
		GetEditCtrl()->GetWindowText(str);
	}

	if (!str.IsEmpty()) {
		BOOL bImage = item.mask & CBEIF_IMAGE;
		BOOL bSelectedImage = item.mask & CBEIF_SELECTEDIMAGE;

		if (bImage) {
			item.iImage = 0;
		}
		if (bSelectedImage) {
			item.iSelectedImage = 0;
		}
	}
	*pResult = 0;
}

/// 摜hbO
void CPatriotAddress::OnDragbegin(NMHDR* pNMHDR, LRESULT* pResult)
{
	LPNMCBEDRAGBEGIN lpDragBegin = (LPNMCBEDRAGBEGIN)pNMHDR;

	CMDIFrameWnd*	 pFrame 	 = (CMDIFrameWnd*)AfxGetMainWnd();
	if (lstrlen(lpDragBegin->szText) == 0 || !pFrame->MDIGetActive()) {
		return;
	}

	CHtmlView2* pView	 = (CHtmlView2*)pFrame->MDIGetActive()->GetActiveView();
	CString 	strURL	 = pView->GetLocationURL();
	CString 	strTitle = pView->GetLocationName();

	if (!strURL.IsEmpty()) {
		// f[^\[Xɓo^
		COleDataSource dataSource;
		::RegistOLEFileContents( dataSource, strTitle, strURL);

		CLIPFORMAT	CF_SHELLURL = CLIPFORMAT( RegisterClipboardFormat(CFSTR_INETURL/*+++CFSTR_SHELLURL*/) );
		HGLOBAL 	hText		= ::CreateOLEText(strURL);
		dataSource.CacheGlobalData(CF_SHELLURL, hText);
		dataSource.CacheGlobalData( BURA_CF_TEXT	  , hText);

		/*+++DROPEFFECT result =*/ dataSource.DoDragDrop( DROPEFFECT_COPY | DROPEFFECT_MOVE | DROPEFFECT_LINK );
	}
	*pResult = 0;
}
