#if !defined(AFX_FILETREECTRL_H__00867233_7A1A_4638_8149_1783D9A89003__INCLUDED_)
#define AFX_FILETREECTRL_H__00867233_7A1A_4638_8149_1783D9A89003__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FileTreeCtrl.h : wb_[ t@C
//

/////////////////////////////////////////////////////////////////////////////
// CFileTreeDropTarget IuWFNg
class CFileTreeDropTarget : public COleDropTarget
{
public:
	CTreeCtrl* m_pTreeWnd;

	CFileTreeDropTarget();
	virtual ~CFileTreeDropTarget();
	virtual void		RegisterWnd(CTreeCtrl* pTreeWnd);
	virtual void		OnDragLeave( CWnd* pWnd );
	virtual DROPEFFECT	OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point );
	virtual DROPEFFECT	OnDropEx( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropDefault, DROPEFFECT dropList, CPoint point );
};


/////////////////////////////////////////////////////////////////////////////
// CFileTreeCtrl EBhE

class CFileTreeCtrl : public CTreeCtrl
{
// RXgNV
public:
	CFileTreeCtrl();

// Agr[g
public:
	CString 			 m_strSuffix;
	CString 			 m_strRootPath;
	HTREEITEM			 m_ClickedItem;
	CString 			 m_strOldFile;
	CString 			 m_strOldItem;
	CFileTreeDropTarget* m_pDropTarget;
	BOOL				 m_bEditing;
	BOOL				 m_bLoaded;
	CPoint				 m_posClicked;
	int 				 m_iIconS;
	int 				 m_iIconN;

	void			AddFolder(CString strPath , HTREEITEM itemParent);
	void			LoadData();
	void			SetOption(CString inRoot , CString inSuffix , int inIcon , int inIconS);
	virtual BOOL	OpenFile(BOOL bNewWindow);
	virtual CMenu*	GetContextMenu();
	virtual void	RegistDropTarget();
	CString 		GetSelectedFileName();
	CString 		GetItemFileName(HTREEITEM item);
	BOOL			ItemIsFolder(HTREEITEM item);

protected:
	void			SetToolTipInfo(CPoint point);

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CFileTreeCtrl)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CFileTreeCtrl();
	virtual BOOL OnDropFiles(HTREEITEM ItemDrop, COleDataObject* pDataObject);
	virtual BOOL OnDropLink(HTREEITEM ItemDrop, CString strTitle, CString strURL);
	virtual BOOL OnDropItem(HTREEITEM ItemDrop, HTREEITEM ItemDrag);
	virtual afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CFileTreeCtrl)
	virtual afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual afx_msg void OnSidebarOpen();
	virtual afx_msg void OnSidebarOpennew();
	virtual afx_msg void OnSidebarRefreshall();
	virtual afx_msg void OnSidebarProperty();
	virtual afx_msg void OnSidebarDelete();
	virtual afx_msg void OnSidebarRename();
	virtual afx_msg void OnSidebarNewfolder();
	virtual afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	virtual afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	virtual afx_msg void OnTimer(UINT_PTR nIDEvent);
	virtual afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	virtual afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	virtual afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	virtual afx_msg void OnClick(NMHDR* pNMHDR, LRESULT* pResult);
	virtual afx_msg void OnEndlabeledit(NMHDR* pNMHDR, LRESULT* pResult);
	virtual afx_msg void OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult);
	virtual afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_FILETREECTRL_H__00867233_7A1A_4638_8149_1783D9A89003__INCLUDED_)
