/////////////////////////////////////////////////////////////////////////////
// PatriotLinkbar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "PatriotLinkbar.h"
#include "PatriotGlobal.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPatriotLinkbar

CPatriotLinkbar::CPatriotLinkbar()
	: arrPath()
	, bShift(0)
	, m_pLinkImages(NULL)
	, m_pLinkImagesDefault(NULL)
{
  #if 0 //+++ Lɗ.
	m_pLinkImages		 = NULL;
	m_pLinkImagesDefault = NULL;
  #endif
}

CPatriotLinkbar::~CPatriotLinkbar()
{
	// C[WXgj󂷂
	if (m_pLinkImages) {
		m_pLinkImages->DeleteImageList();
		delete m_pLinkImages;
		m_pLinkImages = NULL;
	}
}


BEGIN_MESSAGE_MAP(CPatriotLinkbar, CToolBar)
	//{{AFX_MSG_MAP(CPatriotLinkbar)
	ON_WM_CREATE()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPatriotLinkbar bZ[W nh
void CPatriotLinkbar::OpenNewWindow(CPoint point)
{ // ݒƂ͋tŊJ
	CPoint pos;
	CRect  rect;
	GetWindowRect(rect);
	pos.x = point.x - rect.left;
	pos.y = point.y - rect.top;

	bShift = TRUE;
	int Index = GetToolBarCtrl().HitTest(&point);

	if (Index>-1) {
		AfxGetMainWnd()->SendMessage( WM_COMMAND, ID_LINKBAR_LINK + Index );
	}
	bShift = FALSE;
}


int CPatriotLinkbar::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CToolBar::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}

	GetToolBarCtrl().SetExtendedStyle( TBSTYLE_EX_DRAWDDARROWS );
	// XP Visual-Style΍BCreateŏȂ
	ModifyStyle( 0, TBSTYLE_FLAT | TBSTYLE_TOOLTIPS | TBSTYLE_LIST | CCS_NOMOVEY | TBSTYLE_TRANSPARENT/*| CCS_ADJUSTABLE*/);

	// GetToolBarCtrl().SetButtonWidth(16 , 20);
	// GetToolBarCtrl().SetIndent(10);
	// GetToolBarCtrl().SetDrawTextFlags(DT_WORDBREAK , DT_WORDBREAK);
	return 0;
}


void CPatriotLinkbar::OnLButtonUp(UINT nFlags, CPoint point)
{//
	if (nFlags == MK_SHIFT) { // Shift
		OpenNewWindow(point);
		return;
	}
	CToolBar::OnLButtonUp(nFlags, point);
}

void CPatriotLinkbar::OnMButtonUp(UINT nFlags, CPoint point)
{ // {^
	OpenNewWindow(point);
	//CToolBar::OnMButtonUp(nFlags, point);
}

void CPatriotLinkbar::LoadData()
{ // {^̃[h
	// C[WXgݒ
	if (m_pLinkImagesDefault) {
		// j
		if (m_pLinkImages) {
			m_pLinkImages->DeleteImageList();
			delete m_pLinkImages;
			m_pLinkImages = NULL;
		}
		// VKݒ
		CImageList* pImageList	= m_pLinkImagesDefault;
		if (g_Options.LinkLoadImage) {
			int nDefaultCount	= m_pLinkImagesDefault->GetImageCount();
			m_pLinkImages		= new CImageList;
			m_pLinkImages->Create(16, 16, ILC_MASK | ILC_COLOR32, nDefaultCount, 1);
			for (int i = 0; i < nDefaultCount; i++) {
				m_pLinkImages->Add(m_pLinkImagesDefault->ExtractIcon(i));
			}
			m_pLinkImagesDefault->Copy(0, m_pLinkImages, 0);
			pImageList = m_pLinkImages;
		}
		GetToolBarCtrl().SetImageList(pImageList);
	}

	// X^C̕ύX
	GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS | TBSTYLE_EX_MIXEDBUTTONS);

	int  i;
	for (i = 0; i < arrPath.GetSize(); i++) {
		GetToolBarCtrl().DeleteButton(0);
	}

	// t@C
  #if 1 //+++ Os Version֌W𕪗.
	CString 		strFolderPath( g_Options.strFavorites );
	strFolderPath += (COsVersion::MajorVersion() <= 5) ? _T("\\N") : _T("\\Links");
  #else //+++ Os Version֌W𕪗.
	CString 		strFolderPath;
	OSVERSIONINFO	VersionInfo = {0};
	VersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	::GetVersionEx( &VersionInfo );
	if ( VersionInfo.dwMajorVersion <= 5) { // XPȑO
		strFolderPath = g_Options.strFavorites + _T("\\N");
	} else {// Vistaȍ~
		strFolderPath = g_Options.strFavorites + _T("\\Links");
	}
  #endif
	CStringArray	arrTitle;

	if (g_Options.FavoritesIERegist) {// IE
		LoadRegFavorites(arrTitle, strFolderPath);
	} else {//\[g
		LoadArrFolder(arrTitle, strFolderPath, _T("*") );
	}

	if (arrTitle.GetSize() == 0) {
		return;
	}
	// obt@ɒǉ
	arrPath.RemoveAll();
	CString strTitleBuf;
	for (i = 0; i < arrTitle.GetSize(); i++) {
		arrPath.Add(strFolderPath + _T("\\") + arrTitle.GetAt(i));
		strTitleBuf = arrTitle.GetAt(i);
		if (strTitleBuf.ReverseFind('.') >= 0) {
			arrTitle.SetAt( i, strTitleBuf.Left(strTitleBuf.ReverseFind('.')) );
		}
	}

	enum {		BT_SIZE = 200 };	//+++
	TBBUTTON	BT[BT_SIZE];
	int 		arrTitle_size = arrTitle.GetSize();
	if (arrTitle_size >= BT_SIZE)	//+++ `FbNǉ
		arrTitle_size  = BT_SIZE;
	for (i = 0; i < arrTitle_size; i++) {
		BT[i].iString = i;
		// ACR
		// Ver1.0.07 tH_̔ʕ@ύX
		//if (arrPath.GetAt(i).GetAt(arrPath.GetAt(i).GetLength()-4) == '.') {
		if (arrPath.GetAt(i).GetLength() > 5
			&& (arrPath.GetAt(i).Right(4)== _T(".url")
				|| arrPath.GetAt(i).Right(4)== _T(".URL")
				|| arrPath.GetAt(i).Right(4)== _T(".lnk") )) {
			BT[i].iBitmap = 0;

			if (g_Options.LinkLoadImage && arrPath.GetAt(i).Right(4)== _T(".lnk")) {
				// ACȐE
				SHFILEINFO	sfi;
				HIMAGELIST	hSysImgs   = (HIMAGELIST)::SHGetFileInfo(arrPath.GetAt(i), 0, &sfi, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | SHGFI_SMALLICON);
				HICON		hIcon	   = ::ImageList_GetIcon(hSysImgs, sfi.iIcon, ILD_TRANSPARENT);

				CImageList* pImageList = GetToolBarCtrl().GetImageList();
				/*+++  int ncount =*/ pImageList->GetImageCount();
				pImageList->Add(hIcon);
				BT[i].iBitmap		   = pImageList->GetImageCount() - 1;

				DestroyIcon(hIcon);
			}
		} else {
			BT[i].iBitmap  = 2;
		}
		if (!g_Options.LinkImage) { // ACR\
			BT[i].iBitmap  = I_IMAGENONE;
		}
		BT[i].idCommand    = ID_LINKBAR_LINK + i;
		BT[i].fsStyle	   = TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE;
		if (!g_Options.LinkText || BT[i].iBitmap <= 2) {
			// x\
			BT[i].fsStyle |= BTNS_SHOWTEXT;
		}
		BT[i].fsState	   = TBSTATE_ENABLED;
	}

	GetToolBarCtrl().AddButtons(int(arrTitle.GetSize()), BT);
	// xݒ
	for (i = 0;i < arrTitle.GetSize(); i++) {
		SetButtonText( i, arrTitle.GetAt(i) );
	}
	// 폜
	/*
	SetHeight(22);
	SIZE size1 = {23, 22};
	SIZE size2 = {16, 16};
	SetSizes( size1, size2 );
	*/
	GetToolBarCtrl().AutoSize();
}

BOOL CPatriotLinkbar::SysKeyDown(int nVirtKey , long lKeyData)
{ // VXeL[̏
	CString 	strText;
	for (int i = 0;i<GetToolBarCtrl().GetButtonCount();i++) {
		strText = GetButtonText(i);
		if (strText.GetAt(0) == '&' && strText.GetAt(1) == nVirtKey) {
			AfxGetMainWnd()->SendMessage(WM_COMMAND , ID_LINKBAR_LINK + i);
			return TRUE;
		}
	}
	return FALSE;
}

/// C[W̓ǂݍ
void CPatriotLinkbar::SetImageList(CImageList* pImageList)
{
	m_pLinkImagesDefault = pImageList;
}

