//////////////////////////////////////////////////////////////////////
// UrllistFile.h: URLXg̓ǂݏNX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "StdAfx.h"
#include "HtmlView2.h"
#include <afxtempl.h>

class CTravelLogEntry;

class CUrllistItem
{
public:
	CString 		 strURL;
	CString 		 strTitle;
	CString 		 strSetting;
	CTravelLogEntry* pBackEntries;
	CTravelLogEntry* pForwardEntries;

	/// RXgN^
	CUrllistItem();
	/// fXgN^
	~CUrllistItem();
	/// ^uJ
	void Open(BOOL bNewWindow = TRUE, BOOL bActive = FALSE, BOOL bAddLast = TRUE);
	/// ^u̐ݒ擾
	void Get( CHtmlView2* pView );
	/// ^u̐ݒXV
	void Set( CHtmlView2* pView );
};

class CUrllistFile : public CArray< CUrllistItem*, CUrllistItem* >
{
public:
	CUrllistFile();
	~CUrllistFile();

	///
	BOOL Load( CString strFileName = _T("") );
	///
	BOOL Save( CString strFileName = _T("") );
	///
	static BOOL Open( CString strFileName );
	///
	void Destroy();
	///
	int  AddView( CHtmlView2* pView );

protected:
	CString 	m_strFileName;
};
