// EditExtensionDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "EditSendstrDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditSendstrDlg

IMPLEMENT_DYNAMIC(CEditSendstrDlg, CPropertySheet)

CEditSendstrDlg::CEditSendstrDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
	, m_hIcon(0)
	, pageSendstr()
	, pageSendurl()
	, pageSearch()
	, pageAddress()
{
	AddControlPages();
}

CEditSendstrDlg::CEditSendstrDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddControlPages();
}

CEditSendstrDlg::~CEditSendstrDlg()
{
}


BEGIN_MESSAGE_MAP(CEditSendstrDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CEditSendstrDlg)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditSendstrDlg bZ[W nh
void CEditSendstrDlg::AddControlPages()
{ // y[Wǉ
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_psh.dwFlags |= PSP_USEHICON;
	m_psh.hIcon    = m_hIcon;
	m_psh.dwFlags |= PSH_NOAPPLYNOW;	// [Kp] {^Ȃ܂
	m_psh.dwFlags &= ~PSH_HASHELP;	// wv {^Ȃ܂

	g_Options.LoadFolderPath();

	pageSendstr.m_strFileName = _T("sendstr.dat");
	pageSendstr.m_strIniName  = _T("sendstr.ini");
	AddPage(&pageSendstr);
	pageSendurl.m_strFileName = _T("sendurl.dat");
	pageSendurl.m_strIniName  = _T("sendurl.ini");
	AddPage(&pageSendurl);
	pageSearch.m_strFileName  = _T("search.dat");
	pageSearch.m_strIniName   = _T("sendstr.ini");
	AddPage(&pageSearch);
	pageAddress.m_strFileName = _T("addrmenu.dat");
	pageAddress.m_strIniName  = _T("sendurl.ini");
	AddPage(&pageAddress);
}

BOOL CEditSendstrDlg::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();


	TCITEM tcItem = {0};
	tcItem.mask = TCIF_TEXT;
	tcItem.pszText= _T("I𕶎𑗂");
	GetTabControl()->SetItem(0, &tcItem);
	tcItem.pszText= _T("URL𑗂");
	GetTabControl()->SetItem(1, &tcItem);
	tcItem.pszText= _T("o[");
	GetTabControl()->SetItem(2, &tcItem);
	tcItem.pszText= _T("AhXo[");
	GetTabControl()->SetItem(3, &tcItem);
	return bResult;
}

void CEditSendstrDlg::OnOK()
{
	for (int i = 0;i<GetPageCount();i++)
		GetPage(i)->SendMessage(WM_COMMAND , IDOK);
	EndDialog(IDOK);
}
