// ExtensionPageEdit.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "ExtensionPageEdit.h"
#include "..\patriotGlobal2.h"
#include <algorithm>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define WM_RELOAD_SETTING			WM_USER + 112
#define RELOAD_SETTING_EXTENTION	2

/////////////////////////////////////////////////////////////////////////////
// CExtensionPageEdit vpeB y[W

IMPLEMENT_DYNCREATE(CExtensionPageEdit, CPropertyPage)

CExtensionPageEdit::CExtensionPageEdit()
	: CPropertyPage(CExtensionPageEdit::IDD)
	, m_hFrameWnd(0)
	, m_ImageList()
	, m_strAppPath()
	, m_arrExtensionOption()
	, m_arrExtensionAccel()
	, m_Tree()
{
	//{{AFX_DATA_INIT(CExtensionPageEdit)
		//  - ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
}

CExtensionPageEdit::~CExtensionPageEdit()
{
	m_ImageList.DeleteImageList();
}

void CExtensionPageEdit::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExtensionPageEdit)
	DDX_Control(pDX, IDC_TREE1, m_Tree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExtensionPageEdit, CPropertyPage)
	//{{AFX_MSG_MAP(CExtensionPageEdit)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_NOTIFY(TVN_SELCHANGED, IDC_TREE1, OnSelchangedTree1)
	ON_NOTIFY(TVN_ENDLABELEDIT, IDC_TREE1, OnEndlabeleditTree1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExtensionPageEdit \bh
/////////////////////////////////////////////////////////////////////////////

BOOL CExtensionPageEdit::ItemIsGroup(HTREEITEM item)
{ // ACeO[v
	CTreeCtrl* pTreeWnd = (CDragTreeCtrl*)GetDlgItem(IDC_TREE1);
	/*
	if (item == GetRootItem())
		return TRUE;
	*/
	int iImage , iImageSelected;
	if (pTreeWnd->GetItemImage(item , iImage , iImageSelected)) {
		if (iImage == 0 && iImageSelected == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

/// g@\ǉ
BOOL CExtensionPageEdit::AppendItem(const CString& strItem)
{
	int nID = -1;
	for (int i = 0; i < m_arrExtensionOption.GetSize(); i++) {
		if ( m_arrExtensionOption.GetAt(i) == -1 ) {
			nID = i;
			break;
		}
	}
	if (nID == -1) {
		return FALSE;
	}
	// j[̃IvV[h
	CString strIniPath = m_strAppPath + _T("\\extension\\default.ini");

	int mode = GetPrivateProfileInt( strItem, _T("mode"), -1, strIniPath );
	if (mode == -1) {
		strIniPath = m_strAppPath+ _T("\\extension\\user.ini");
		mode = GetPrivateProfileInt( strItem, _T("mode"), -1, strIniPath );
	}

	int iMenuOption = 0;
	if (mode == 0) {
		TCHAR chrUrl[MAX_PATH];
		::GetPrivateProfileString( strItem, _T("url"), _T(""), chrUrl, MAX_PATH, strIniPath );
		if ( _tcsstr( chrUrl, _T("script:") ) ) {
			iMenuOption = 2;
		}
	} else if ( mode == 2 ) {
		iMenuOption = 2;
	} else {
		iMenuOption = ::GetPrivateProfileInt( strItem, _T("menu"), 0, strIniPath );
	}

	// ANZ[^
	TCHAR chrAccel[MAX_PATH];
	::GetPrivateProfileString( strItem, _T("accel"), _T(""), chrAccel, MAX_PATH, strIniPath );

	// c[ɒǉ
	int nIcon = (iMenuOption == 2) ? 2 : 1 ;
	CTreeCtrl* pTreeWnd = (CDragTreeCtrl*)GetDlgItem(IDC_TREE1);
	HTREEITEM itemParent = pTreeWnd->GetSelectedItem();
	if ( !ItemIsGroup(itemParent) ) {
		itemParent = pTreeWnd->GetParentItem( itemParent );
	}
	HTREEITEM item = pTreeWnd->InsertItem( TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_PARAM | TVIF_TEXT, strItem, nIcon, nIcon, 0, 0, nID, itemParent, TVI_LAST);

	m_arrExtensionOption.SetAt( nID, iMenuOption );
	m_arrExtensionAccel.SetAt( nID, chrAccel[0] );
	return TRUE;
}

/// ݒ
BOOL CExtensionPageEdit::ConfigItem(const CString& strItem)
{
	CString strExtensionName = strItem;
	CString strIniPath = m_strAppPath+ _T("\\extension\\user.ini");

	int mode = GetPrivateProfileInt(strExtensionName, _T("mode"), -1, strIniPath);
	if (mode == -1) {
		strIniPath = m_strAppPath+ _T("\\extension\\default.ini");
		mode = GetPrivateProfileInt(strExtensionName, _T("mode"), -1, strIniPath);
	}
	if (mode == 0) { // javascript
		/*
		TCHAR chrBuf[MAX_PATH*8];
		GetPrivateProfileString(strExtensionName, _T("url") , "" , chrBuf , MAX_PATH*8 , strIniPath);
		CString strURL = chrBuf;
		*/
	}
	else if (mode == 1) { // DLL
		TCHAR chrBuf[MAX_PATH];
		GetPrivateProfileString(strExtensionName, _T("dll"), _T(""), chrBuf, MAX_PATH, strIniPath);
		CString strDll = chrBuf;
		GetPrivateProfileString(strExtensionName, _T("func"), _T(""), chrBuf, MAX_PATH, strIniPath);
		CString strFunc = chrBuf;
		/*
		GetPrivateProfileString(strExtensionName, _T("param") , "" , chrBuf , MAX_PATH , strIniPath);
		CString strParam = chrBuf;

		LPDISPATCH pDisp;
		if (m_Tabs.count>0)
			pDisp = ((CPatriotView*)m_Tabs.pView[m_wndTabBar.GetCurSel()])->GetWebBrowserApp();
		else
			pDisp = NULL;
		*/

		int iResult = 0;
		HMODULE hMod = (HMODULE)LoadLibrary( m_strAppPath+_T("\\extension\\")+strDll );
		if (hMod) {
			typedef BOOL (WINAPI EXECPLUGIN)(HWND , LPCTSTR);
			EXECPLUGIN* lpfnExecPlugin = (EXECPLUGIN*)GetProcAddress(hMod,	"ShowConfig" );
			if (lpfnExecPlugin){
				iResult = lpfnExecPlugin(m_hFrameWnd , strFunc);
				if (iResult == 0) {
					AfxMessageBox( _T("ShowConfig̎sɃG[܂B") );
				}
			} else {
				AfxMessageBox( _T("ShowConfig̎擾Ɏs܂B") );
			}
			FreeLibrary(hMod);
		} else{
			AfxMessageBox(strDll+ _T("̓ǂݍ݂Ɏs܂B") );
		}
	}
	else if (mode == 2) { // Oscript
		/*
		TCHAR chrBuf[MAX_PATH*8];
		GetPrivateProfileString(strExtensionName, _T("src") , "" , chrBuf , MAX_PATH*8 , strIniPath);
		*/
	}
	return TRUE;
}

BOOL CExtensionPageEdit::DeleteItem(HTREEITEM item)
{ // ACe폜
	CTreeCtrl* pTreeWnd = (CDragTreeCtrl*)GetDlgItem(IDC_TREE1);

	if ( ItemIsGroup(item) )
	{ // O[v
		HTREEITEM itemChild;
		while( itemChild = pTreeWnd->GetChildItem( item ) )
			DeleteItem(itemChild);
		pTreeWnd->DeleteItem(item);
	}
	else if ( pTreeWnd->GetItemText(item).GetLength()>=3 && pTreeWnd->GetItemText(item).Left(3)== _T("---")  )
	{ // Zp[^
		m_arrExtensionOption.SetAt( pTreeWnd->GetItemData( item ) , -1 );
		m_arrExtensionAccel .SetAt( pTreeWnd->GetItemData( item ) ,  0 );
		pTreeWnd->DeleteItem( item );
	}
	else
	{ // ACe
		pTreeWnd->DeleteItem( item );
	}
	return TRUE;
}

/// ݒo
CString CExtensionPageEdit::OutputNode( HTREEITEM itemParent, int iTabIndent )
{
	if (itemParent == NULL) {
		return	_T("");
	}
	CString strResult = _T("");
	CString strTab( _T('\t'), iTabIndent );

	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	HTREEITEM item = itemParent;
	while ( item ) {
		CString strItem = pTreeWnd->GetItemText(item);
		if ( ItemIsGroup(item) ) { // O[v
			int i = strItem.Find( _T("(&") );
			if ( i > 0 ) {
				strItem  = strItem.Left(i) + _T(",") + strItem.Mid( i+2 , 1 );
			}
			strResult+= strTab +  _T("GROUP:") + strItem + _T("\n");
			strResult+= OutputNode( pTreeWnd->GetChildItem(item) , iTabIndent+1 );
			strResult+= strTab +  _T("ENDGROUP\n");
		}
		else if ( strItem.GetLength()>2 && strItem.Left(2)== _T("--")  ) { // Zp[^
			strResult+= strTab + _T("SEPARATOR\n");
		}
		else{ // ACe
			DWORD_PTR	nID = pTreeWnd->GetItemData(item);	//+++@
			CString 	str;

			if (m_arrExtensionAccel.GetAt(nID)) {
				str.Format(_T("ITEM:%s,%c,%d,%d\n") , strItem , m_arrExtensionAccel.GetAt(nID) , m_arrExtensionOption.GetAt(nID) , nID );
			} else {
				str.Format(_T("ITEM:%s,,%d,%d\n") , strItem , m_arrExtensionOption.GetAt(nID) , nID );
			}
			strResult += strTab + str;
		}
		item = pTreeWnd->GetNextSiblingItem(item);
	}
	return strResult;
}

/// j[ɓo^ς݂̊g
void CExtensionPageEdit::EnumTreeItems(const CTreeCtrl* pTreeWnd, std::vector<CString>& strItemNames)
{
	HTREEITEM item = pTreeWnd->GetRootItem();
	while (item) {
		while (pTreeWnd->ItemHasChildren(item)) {
			item = pTreeWnd->GetChildItem(item);
		}
		// 񋓂vfo^
		strItemNames.push_back(pTreeWnd->GetItemText(item));

		HTREEITEM itemNext = pTreeWnd->GetNextSiblingItem(item);
		if (itemNext == NULL) {
			itemNext = pTreeWnd->GetParentItem(item);
			if (itemNext) {
				itemNext = pTreeWnd->GetNextSiblingItem(itemNext);
			}
		}
		item = itemNext;
	}
}

/// g@\̖O
void CExtensionPageEdit::EnumExtensionNames(const CString& strFileName, CStringVector& strItemNames, CStringVector& strRegisteredItemNames)
{
	TRY{
		CString str;
		//+++ CStdioFile sfo(strFileName, CFile::modeRead | CFile::modeNoTruncate);
		CReadTextFile sfo(strFileName, CFile::modeRead | CFile::modeNoTruncate);
		while (sfo.ReadString(str)) {
			if (!str.IsEmpty() && str.GetAt(0) == _T('[')) {
				str = str.Mid(1, str.GetLength() - 2);
				if (std::find(strRegisteredItemNames.begin(), strRegisteredItemNames.end(), str) == strRegisteredItemNames.end()) {
					strItemNames.push_back(str);
					strRegisteredItemNames.push_back(str);
				}
			}
		}
		sfo.Close();
	}
	CATCH( CFileException, e){
	}END_CATCH
}

/////////////////////////////////////////////////////////////////////////////
// CExtensionPageEdit bZ[W nh
/////////////////////////////////////////////////////////////////////////////

BOOL CExtensionPageEdit::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// 
	int i = 0;
	m_arrExtensionOption.RemoveAll();
	m_arrExtensionOption.SetSize(256);
	for (i = 0; i < 256; i++) {
		m_arrExtensionOption.SetAt( i , -1 );
	}

	m_arrExtensionAccel.RemoveAll();
	m_arrExtensionAccel.SetSize(256);
	for (i = 0; i < 256; i++) {
		m_arrExtensionAccel.SetAt( i, 0 );
	}

	CDragTreeCtrl* pTree = (CDragTreeCtrl*)GetDlgItem(IDC_TREE1);
	pTree->LoadBmp(IDB_EXTPAGE_TREE);
	// bura.exêtH_
	TCHAR chrAppPath[MAX_PATH];
	lstrcpyn( chrAppPath, AfxGetApp()->m_pszHelpFilePath, MAX_PATH );
	*_tcsrchr( chrAppPath, _T('\\') ) = NULL;
	m_strAppPath = chrAppPath;

	// c[̍\z
	CString str;
	HTREEITEM itemCurFolder = pTree->GetRootItem();
	//+++ CStdioFile fin( g_Options.strOptionPath + _T("\\extension.dat"), CFile::modeRead );
	CReadTextFile fin( g_Options.strOptionPath + _T("\\extension.dat"), CFile::modeRead );
	while (fin.ReadString(str)) {
		str.TrimLeft();

		if (str.GetLength() >= 5 && str.Left(5) == _T("ITEM:") ) {
			// ACe
			str = str.Mid( 5 );
			//str = str.Right( str.GetLength() - 5 );

			CString strName , strAccel , strID;
			SplitStr( str, _T(','), strName,  str	);
			SplitStr( str, _T(','), strAccel, str	);
			SplitStr( str, _T(','), str,	  strID );

			UINT nID = _ttoi(strID);
			UINT nOption = _ttoi(str);
			int nIcon = (nOption == 2) ? 2 :1 ;

			pTree->InsertItem( TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_PARAM | TVIF_TEXT , strName , nIcon , nIcon	, 0 , 0 , nID  , itemCurFolder , TVI_LAST);
			m_arrExtensionOption.SetAt( nID , nOption );
			if ( !strAccel.IsEmpty() ) {
				m_arrExtensionAccel.SetAt( nID , strAccel.GetAt(0) );
			}
		} else if (str.GetLength()>=6 && str.Left(6)== _T("GROUP:") ) {
			// O[vJn
			str = str.Mid(6);
			//str = str.Right(str.GetLength()-6);
			CString strAccel;
			SplitStr( str, _T(','), str, strAccel);

			if (strAccel!= _T("") ) {
				str = str + _T("(&") + strAccel + _T(")");
			}

			itemCurFolder = pTree->InsertItem( str, 0, 0, itemCurFolder, TVI_LAST );
		} else if ( str.GetLength() >= 8 && str.Left(8) == _T("ENDGROUP") ) {
			// O[vI
			itemCurFolder = pTree->GetParentItem(itemCurFolder);
		} else if ( str.GetLength() >= 9 && str.Left(9) == _T("SEPARATOR") ) {
			// Zp[^[
			pTree->InsertItem( _T("--------------------")  , 1 , 1 , itemCurFolder , TVI_LAST);
		}
	}
	fin.Close();

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/// ǉ
void CExtensionPageEdit::OnButton1()
{
	// |bvAbvj[\
	CRect rect;
	GetDlgItem(IDC_BUTTON1)->GetWindowRect(rect);
	// j[\z
	CMenu menu;
	menu.CreatePopupMenu();
	CMenu menuProfile;
	menuProfile.CreatePopupMenu();

	CString str;
	CStringVector strRegisteredExtensionNames;

	// j[ɓo^ς݂̊g
	CTreeCtrl* pTreeWnd = (CDragTreeCtrl*)GetDlgItem(IDC_TREE1);
	EnumTreeItems(pTreeWnd, strRegisteredExtensionNames);

	// t@Cǂݍ
	CStringVector strExtensionNames;
	EnumExtensionNames(m_strAppPath+ _T("\\extension\\user.ini"), strExtensionNames, strRegisteredExtensionNames);
	int nMenuID = 2;
	CStringVector::iterator i;
	for (i = strExtensionNames.begin(); i != strExtensionNames.end(); i++) {
		menuProfile.AppendMenu(MF_STRING, ID_EXTENSION_EXTENSION + nMenuID, *i);
		nMenuID++;
	}

	if (menuProfile.GetMenuItemCount() > 0) {
		menuProfile.AppendMenu(MF_SEPARATOR, 0,  _T(""));
	}
	strExtensionNames.empty();

	EnumExtensionNames(m_strAppPath+ _T("\\extension\\default.ini"), strExtensionNames, strRegisteredExtensionNames);
	for (i = strExtensionNames.begin(); i != strExtensionNames.end(); i++) {
		menuProfile.AppendMenu(MF_STRING, ID_EXTENSION_EXTENSION + nMenuID, *i);
		nMenuID++;
	}

	menu.AppendMenu(MF_STRING, ID_EXTENSION_EXTENSION + 0, _T("O[v̒ǉ(&G)"));
	menu.AppendMenu(MF_STRING, ID_EXTENSION_EXTENSION + 1, _T("؂̒ǉ(&S)"));

	menu.AppendMenu(MF_POPUP | MF_STRING, (UINT)menuProfile.m_hMenu, _T("g̒ǉ(&E)"));
	// \
	UINT nID = TrackPopupMenu(menu.m_hMenu,
						TPM_LEFTALIGN /*| TPM_RIGHTBUTTON*/ | TPM_RETURNCMD,
						rect.left, rect.bottom, 0, m_hWnd, NULL );

	menuProfile.DestroyMenu();
	menu.DestroyMenu();

	if (nID == 0) {
		return;
	}
	// c[ɒǉ
	HTREEITEM itemParent = pTreeWnd->GetSelectedItem();
	if ( !ItemIsGroup(itemParent) ) {
		itemParent = pTreeWnd->GetParentItem( itemParent );
	}
	HTREEITEM item = NULL;
	switch (nID - ID_EXTENSION_EXTENSION) {
	case 0://O[v
		item = pTreeWnd->InsertItem( _T(""), 0, 0, itemParent, TVI_LAST );
		break;
	case 1://Zp[^
		item = pTreeWnd->InsertItem( _T("--------------------"), 1, 1, itemParent, TVI_LAST );
		break;
	default://ACe
		CString strItem = strExtensionNames[nID - ID_EXTENSION_EXTENSION - 2];
		AppendItem(strItem);
		break;
	}
	pTreeWnd->SelectItem(item);
}

/// 폜
void CExtensionPageEdit::OnButton2()
{
	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	HTREEITEM item = pTreeWnd->GetSelectedItem();

	if (pTreeWnd->GetItemText(item).Find(_T("----")) != 0) {
		if (AfxMessageBox(_T("g@\j[폜ĂA̋@\ւ̃V[gJbg̊蓖ĂȂǂ͎蓮ō폜Ȃ΂Ȃ܂B") , MB_OKCANCEL | MB_ICONINFORMATION) == IDCANCEL) {
			return;
		}
	}
	DeleteItem(item);
}

/// ݒ
void CExtensionPageEdit::OnButton3()
{
	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	ASSERT(pTreeWnd->GetSelectedItem() != NULL);
	CString strItem = pTreeWnd->GetItemText(pTreeWnd->GetSelectedItem());
	ConfigItem(strItem);
}

/// O̕ύX
void CExtensionPageEdit::OnButton4()
{
	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);

	pTreeWnd->ModifyStyle(0 , TVS_EDITLABELS);
	pTreeWnd->EditLabel( pTreeWnd->GetSelectedItem() );
}

void CExtensionPageEdit::OnSelchangedTree1(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	BOOL bGroup = ItemIsGroup( pNMTreeView->itemNew.hItem );
	if ( !bGroup ) {
		CString strExtensionName = pTreeWnd->GetItemText( pNMTreeView->itemNew.hItem );
		CString strIniPath = m_strAppPath+ _T("\\extension\\user.ini");
		int mode = GetPrivateProfileInt(strExtensionName, _T("mode") , -1 , strIniPath);
		if (mode == -1) {
			strIniPath = m_strAppPath+ _T("\\extension\\default.ini");
			mode = GetPrivateProfileInt(strExtensionName, _T("mode") , -1 , strIniPath);
		}
		GetDlgItem(IDC_BUTTON3)->EnableWindow( mode == 1 );
	} else {
		GetDlgItem(IDC_BUTTON3)->EnableWindow( FALSE );
	}

	GetDlgItem(IDC_BUTTON4)->EnableWindow(	bGroup );

	*pResult = 0;
}

/// ݒ̕ۑ
void CExtensionPageEdit::OnOK()
{
	CTreeCtrl* pTreeWnd = static_cast<CTreeCtrl*>( GetDlgItem(IDC_TREE1) );
	CString strResult = OutputNode( pTreeWnd->GetRootItem(), 0 );

	//+++ CStdioFile fso( g_Options.strOptionPath +  _T("\\extension.dat"), CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile fso( g_Options.strOptionPath +  _T("\\extension.dat"), CFile::modeCreate | CFile::modeWrite);
	fso.WriteString(strResult);
	fso.Close();

	::SendMessage( m_hFrameWnd, WM_RELOAD_SETTING, RELOAD_SETTING_EXTENTION, 0 );
	CPropertyPage::OnOK();
}


/// OύX̏I
void CExtensionPageEdit::OnEndlabeleditTree1(NMHDR* pNMHDR, LRESULT* pResult)
{
	TV_DISPINFO* pTVDispInfo = (TV_DISPINFO*)pNMHDR;

	CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
	if ( pTVDispInfo->item.pszText != 0 && GetKeyState(VK_RETURN)!=FALSE ) {
		pTreeWnd->SetItemText( pTreeWnd->GetSelectedItem() , pTVDispInfo->item.pszText );
		*pResult = 0;
	}
	pTreeWnd->ModifyStyle(TVS_EDITLABELS , 0);
	*pResult = 0;
}

BOOL CExtensionPageEdit::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN) {
		// ^[L[
		if (pMsg->wParam == VK_RETURN) {
			CTreeCtrl* pTreeWnd = (CTreeCtrl*)GetDlgItem(IDC_TREE1);
			if (pTreeWnd->GetEditControl()!=NULL) {
				SetFocus();
				return TRUE;
			}
		}
	}
	return CPropertyPage::PreTranslateMessage(pMsg);
}
